# This file is a template, and might need editing before it works on your project.
# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Getting-Started.gitlab-ci.yml

# This is a sample GitLab CI/CD configuration file that should run without any modifications.
# It demonstrates a basic 3 stage CI/CD pipeline. Instead of real tests or scripts,
# it uses echo commands to simulate the pipeline execution.
#
# A pipeline is composed of independent jobs that run scripts, grouped into stages.
# Stages run in sequential order, but jobs within stages run in parallel.
#
# For more information, see: https://docs.gitlab.com/ee/ci/yaml/index.html#stages
image: maven:3.8.3-amazoncorretto-8

  
stages:
  - clean          # List of stages for jobs, and their order of execution
  - compile
  - build
  - test
  - package
  - deploy
# include:
#   - template: Code-Quality.gitlab-ci.yml

# code_quality_html:
#   extends: code_quality
#   stage: test
#   variables:
#     REPORT_FORMAT: html
#   artifacts:
#     paths: [gl-code-quality-report.html]


# docker-build:
#   stage: deploy
#   image: docker:latest
#   script:
#     - docker build -t alenope/test .
#     - docker login -u $DOCKER_USERNAME -p $DOCKER_PASSWORD docker.io
#     - docker push index.docker.io/alenope/test

cache:
  paths:
    - .m2/repository
  key: "$CI_BUILD_REF_NAME"
compile-job:
  stage : compile
  script : "mvn package"
  artifacts:
     paths: [./target/myproject-0.0.1-SNAPSHOT-jar-with-dependencies.jar]
# build-job:
#   stage : build
#   script : "mvn build"
# package-job:
#   stage : package
#   script : "mvn package -DskipTests=true"
#   artifacts:
#     paths: [./target/testBuild-0.0.1-SNAPSHOT.jar]
  
# test-job:
#   stage: test
#   script: "mvn test"
variables:
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar"  # Defines the location of the analysis task cache
  GIT_DEPTH: "0"  # Tells git to fetch all the branches of the project, required by the analysis task
  MAVEN_OPTS: "-Djava.awt.headless=true -Dmaven.repo.local=./.m2/repository"
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version"

sonarcloud-check:
  image: maven:3.8.3-amazoncorretto-8
  cache:
    key: "${CI_JOB_NAME}"
    paths:
      - .sonar/cache
  script:
    - mvn package sonar:sonar -Dsonar.projectKey=bert.dud2011_ProjetRPG
  only:
    - merge_requests
    - master
    - develop


